unit LDUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, CDRIP, LameCoder;

type
  TForm1 = class(TForm)
    LameCoder1: TLameCoder;
    CDRIP1: TCDRIP;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    CheckBox3: TCheckBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Label4: TLabel;
    CheckBox6: TCheckBox;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Label5: TLabel;
    ListBox2: TListBox;
    Button4: TButton;
    Button5: TButton;
    ProgressBar1: TProgressBar;
    Label6: TLabel;
    ComboBox3: TComboBox;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Label7: TLabel;
    CheckBox7: TCheckBox;
    ComboBox4: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    ComboBox5: TComboBox;
    Label10: TLabel;
    CheckBox8: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CDRIP1Progress(Sender: TObject; PercentComplete: Word);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CDRIP1BeginTrack(Sender: TObject; TrackNum: Word);
    procedure CDRIP1EndTrack(Sender: TObject; TrackNum: Word);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure LameCoder1Progress(Sender: TObject; PercentComplete: Word);
    procedure LameCoder1EndProcess(Sender: TObject);
    procedure LameCoder1BeginFile(Sender: TObject; Num: Word;
      FileName: String);
    procedure TrackBar1Change(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Lame_dll;

{$R *.DFM}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
     CheckBox2.Checked := not CheckBox1.Checked;
     CDRIP1.Encode:=CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     CheckBox1.Checked := not CheckBox2.Checked;
     CDRIP1.WriteWAV:=CheckBox2.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     ListBox1.Items.Assign(CDRIP1.Tracks);
     ListBox1.ItemIndex:=0;
     ComboBox1.ItemIndex:=0;
     ComboBox2.ItemIndex:=1;
     ComboBox3.ItemIndex:=0;
     ComboBox4.ItemIndex:=0;
     ComboBox5.ItemIndex:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var f : string;
begin
     f:=ListBox1.Items[ListBox1.ItemIndex];
     if CDRIP1.WriteWAV then f:=f+'.wav' else f:=f+'.pcm';
     CDRIP1.RipTrack(ListBox1.ItemIndex+1,f);
end;

procedure TForm1.CDRIP1Progress(Sender: TObject; PercentComplete: Word);
begin
     ProgressBar1.Position:=PercentComplete;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     CDRIP1.CancelRip;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     LameCoder1.SampleRate:=StrToInt(ComboBox1.Text);
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
     LameCoder1.BitRate:=StrToInt(ComboBox2.Text);
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
     LameCoder1.MaxBitRate:=StrToInt(ComboBox3.Text);
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
     LameCoder1.EnableVBR:=CheckBox6.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     LameCoder1.Copyright:=CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
     LameCoder1.Original:=CheckBox4.Checked;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
     LameCoder1.CRC:=CheckBox5.Checked;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     if OpenDialog1.Execute then begin
        LameCoder1.InputFiles:=OpenDialog1.Files;
        ListBox2.Items.Assign(OpenDialog1.Files);
     end;
end;

procedure TForm1.CDRIP1BeginTrack(Sender: TObject; TrackNum: Word);
begin
     Label5.Caption:='Begin ripping Track' + inttostr(tracknum);
end;

procedure TForm1.CDRIP1EndTrack(Sender: TObject; TrackNum: Word);
begin
     Label5.Caption:='End ripping Track' + inttostr(tracknum);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     LameCoder1.ProcessFiles;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     LameCoder1.CancelProcess;
end;

procedure TForm1.LameCoder1Progress(Sender: TObject;
  PercentComplete: Word);
begin
     ProgressBar1.Position:=PercentComplete;
end;

procedure TForm1.LameCoder1EndProcess(Sender: TObject);
begin
     ProgressBar1.Position:=0;
end;

procedure TForm1.LameCoder1BeginFile(Sender: TObject; Num: Word;
  FileName: String);
begin
     Label6.Caption:='Process file '+FileName;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
     LameCoder1.VBRQuality:=TrackBar1.Position;
     Label7.Caption:=IntToStr(TrackBar1.Position);
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
     LameCoder1.WriteVBRHeader:=CheckBox7.Checked;
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
     LameCoder1.Mode:=TLameMode(ComboBox4.ItemIndex);
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
     LameCoder1.Quality:=MPEG_QUALITY(ComboBox5.ItemIndex);
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
     LameCoder1.Private:=CheckBox8.Checked;
end;

end.
